VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Files"
   ClientHeight    =   5685
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   8715
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5685
   ScaleWidth      =   8715
   Begin VB.TextBox txtFiles 
      Height          =   1815
      Left            =   2280
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox DirList 
      Height          =   1440
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private FName As String

Private Type SHFILEOPSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Long
    hNameMappings As Long
    lpszProgressTitle As Long '  only used if FOF_SIMPLEPROGRESS
End Type
Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40
' Use Quicksort to sort a list of strings.
'
' This code is from the book "Ready-to-Run
' Visual Basic Algorithms" by Rod Stephens.
' http://www.vb-helper.com/vba.htm
Private Sub Quicksort(list() As String, ByVal min As Long, ByVal max As Long)
Dim mid_value As String
Dim hi As Long
Dim lo As Long
Dim i As Long

    ' If there is 0 or 1 item in the list,
    ' this sublist is sorted.
    If min >= max Then Exit Sub

    ' Pick a dividing value.
    i = Int((max - min + 1) * Rnd + min)
    mid_value = list(i)

    ' Swap the dividing value to the front.
    list(i) = list(min)

    lo = min
    hi = max
    Do
        ' Look down from hi for a value < mid_value.
        Do While list(hi) >= mid_value
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            list(lo) = mid_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(lo) = list(hi)

        ' Look up from lo for a value >= mid_value.
        lo = lo + 1
        Do While list(lo) < mid_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            list(hi) = mid_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(hi) = list(lo)
    Loop

    ' Sort the two sublists.
    Quicksort list, min, lo - 1
    Quicksort list, lo + 1, max
End Sub
Private Sub DirList_Change()
Dim dir_path As String
Dim files() As String
Dim txt As String
Dim i As Integer

    ' Get the files.
    dir_path = DirList.Path
    If Right$(dir_path, 1) <> "\" Then dir_path = dir_path & "\"
    dir_path = dir_path
    files = SortedFiles(dir_path)

    Caption = UBound(files) & " Files"

    On Error GoTo NoFiles
    For i = LBound(files) To UBound(files)
        txt = txt & vbCrLf & files(i)
    Next i

    txtFiles.Text = Mid$(txt, 3)
    Exit Sub

NoFiles:
    txtFiles.Text = ""
End Sub

' Return an array containing the names of the
' files in the directory sorted alphabetically.
Private Function SortedFiles(ByVal dir_path As String, Optional ByVal exclude_self As Boolean = True, Optional ByVal exclude_parent As Boolean = True) As String()
Dim fso As FileSystemObject
Dim fso_folder As Folder
Dim txt As String
Dim fso_file As File
Dim i As Long
Dim file_names() As String

    ' Make a new File System object.
    Set fso = New FileSystemObject

    ' Get the FSO Folder (directory) object.
    Set fso_folder = fso.GetFolder(dir_path)

    ' Make the list of names.
    ReDim file_names(1 To fso_folder.files.Count)
    i = 1
    For Each fso_file In fso_folder.files
        file_names(i) = fso_file.Name
        i = i + 1
    Next fso_file

    ' Sort the list of files.
    Quicksort file_names, 1, fso_folder.files.Count

    ' Return the sorted list.
    SortedFiles = file_names
End Function
Private Sub DriveList_Change()
    'On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


' If the user presses the Delete key, delete the
' currently displayed file.
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Dim op As SHFILEOPSTRUCT

    If (KeyCode = vbKeyDelete) And (Len(FName) > 0) Then
        With op
            .wFunc = FO_DELETE
            .pFrom = FName
            .fFlags = FOF_ALLOWUNDO
        End With

        On Error Resume Next
        SHFileOperation op

        If Err.Number > 0 Then
            MsgBox "Error " & Format$(Err.Number) & _
                " deleting file " & FName & _
                vbCrLf & Err.Description
        Else
            FName = ""
            Caption = "ViewFile"
            DirList_Change
        End If
        On Error GoTo 0
    End If
End Sub

Private Sub Form_Resize()
Const GAP = 60

Dim wid As Single
Dim hgt As Single
Dim lft As Single

    If WindowState = vbMinimized Then Exit Sub

    wid = DriveList.Width
    DriveList.Move GAP, GAP, wid

    hgt = ScaleHeight - (DriveList.Top + DriveList.Height) - GAP
    If hgt < 100 Then hgt = 100
    DirList.Move GAP, DriveList.Top + DriveList.Height + GAP, wid, hgt

    lft = DriveList.Width + 2 * DriveList.Left
    wid = ScaleWidth - lft
    If wid < 120 Then wid = 120
    txtFiles.Move lft, 0, wid, ScaleHeight
End Sub
